//+--------------------------------------------------------------------------------------------+
//|                                                                         spreadProfitV5.mq4 |
//|                                                                                       adeo |
//+--------------------------------------------------------------------------------------------+


#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1  Green
#property indicator_level1  0

//TODO how to preserve configured externs after compile??
extern string  __SP              = "spreadProfit: Buy=true Sell=false";
extern string  spreadCurrency1   = "GBPJPY";
extern double  spreadOpen1       = 131.0;
extern bool    spreadAction1     = true;
extern string  spreadCurrency2   = "EURCHF";
extern double  spreadOpen2       = 1.2700;
extern bool    spreadAction2     = false;

static double  investment;
static double  accounttype;
static double  lotsize1, lotprice1;
static double  lotsize2, lotprice2;
static double  pair1, pair2;
static double  amountpair1, amountpair2;
static double  lot1, lot2;
static string  symbol;
static string  CurrencyConversion1;
static string  CurrencyConversion2;
static string  Pair1Curr1;
static string  Pair2Curr1;
static string  Pair1Curr2;
static string  Pair2Curr2;

int      error;
int      symbol_length;
double   test;
double   sp[];
string   symbol_appendix;

//------------------------------------------------------------------------
//
//
int init()
{

   if(spreadOpen1 <= 0 || spreadOpen2 <= 0){
      Print("Bad spreadOpen value(s): "+DoubleToStr(spreadOpen1,2)+","+DoubleToStr(spreadOpen2,2));
      deinit();
   }
   
//TODO spread symbol case conversion (all to uppercase?)
//TODO Data integrity checks and error detection / traps
   symbol  = Symbol();
   symbol_length = StringLen(symbol);
   symbol_appendix = "";
   if((symbol_length > 6) && (MarketInfo(spreadCurrency1,MODE_PROFITCALCMODE) == 0.0)){   
      symbol_appendix = StringSubstr(symbol,6);
      spreadCurrency1 = spreadCurrency1 + symbol_appendix;
      spreadCurrency2 = spreadCurrency2 + symbol_appendix;
   }

   bool test = PairExists(spreadCurrency1);
   if (!test){
      Print("Bad spreadCurrency1: "+spreadCurrency1);
      deinit();
   }
   test = PairExists(spreadCurrency2);
   if (!test){
      Print("Bad spreadCurrency2: "+spreadCurrency2);
      deinit();
   }
   
   //Print("spreadCurrency1="+spreadCurrency1+", spreadCurrency2="+spreadCurrency2);

   Pair1Curr1 = StringSubstr(spreadCurrency1,0,3);
   Pair2Curr1 = StringSubstr(spreadCurrency2,0,3);
   Pair1Curr2 = StringSubstr(spreadCurrency1,3,3);
   Pair2Curr2 = StringSubstr(spreadCurrency2,3,3);
   
     //---- initialization values of constants --------------------------------------------------+
   lotsize1 = MarketInfo(spreadCurrency1,MODE_LOTSIZE);
   lotprice1 = lotsize1 / AccountLeverage();
   lotsize2 = MarketInfo(spreadCurrency2,MODE_LOTSIZE);
   lotprice2 = lotsize2 / AccountLeverage();
/*
   if ((lotsize1*MarketInfo(spreadCurrency1,MODE_LOTSIZE)/100) >= (lotsize2*MarketInfo(spreadCurrency2,MODE_LOTSIZE)/100)){
      investment = MarketInfo(spreadCurrency1,MODE_LOTSIZE) / 100;
   }
   else{
      investment = MarketInfo(spreadCurrency2,MODE_LOTSIZE) / 100;
   }   
*/
      investment = 1000;
//TODO resolve forex and CFD contract size and margin differences
//TODO *Especially* when trading Forex vs CFD; e.g. XAUUSD & .WTI
//      Print("@investment="+MarketInfo(spreadCurrency1,MODE_LOTSIZE));

   //spreadCurrency1 in USD
   pair1 = 0.0;
   if (Pair1Curr1 == "USD"){
      pair1 = 1.0;
   }   
   else if (Pair1Curr2 == "USD"){
      pair1 = MarketInfo(spreadCurrency1,MODE_ASK);
   }
   else if ((Pair1Curr2 != "USD") && (Pair1Curr2 != "USD") && (MarketInfo(spreadCurrency1,MODE_PROFITCALCMODE) == 0)){
      pair1 = MarketInfo(Pair1Curr1+"USD"+symbol_appendix,MODE_ASK);
      if (pair1 == 0.0){
         pair1 = 1.0 / MarketInfo("USD"+Pair1Curr1+symbol_appendix,MODE_ASK);
      }   
   }
   else if (MarketInfo(spreadCurrency1,MODE_PROFITCALCMODE) != 0){
      pair1 = MarketInfo(spreadCurrency1,MODE_ASK);
   }
   else{
      Print("Cannot find spreadCurrency1 in USD; Pair1Curr1="+Pair1Curr1+" Pair1Curr2="+Pair1Curr2+" App="+symbol_appendix+" Mode="+MarketInfo(spreadCurrency1,MODE_PROFITCALCMODE));
      deinit();
   }   

   //spreadCurrency2 in USD
   pair2 = 0.0;
   if (Pair2Curr1 == "USD"){
      pair2 = 1.0;
   }   
   else if (Pair2Curr2 == "USD"){
      pair2 = MarketInfo(spreadCurrency2,MODE_ASK);
   }
   else if ((Pair2Curr2 != "USD") && (Pair2Curr2 != "USD") && (MarketInfo(spreadCurrency2,MODE_PROFITCALCMODE) == 0)){
      pair2 = MarketInfo(Pair2Curr1+"USD"+symbol_appendix,MODE_ASK);
      if (pair2 == 0.0){
         pair2 = 1.0 / MarketInfo("USD"+Pair2Curr1+symbol_appendix,MODE_ASK);
      }   
   }
   else if (MarketInfo(spreadCurrency2,MODE_PROFITCALCMODE) != 0){
      pair2 = MarketInfo(spreadCurrency2,MODE_ASK);
   }
   else{
      Print("Cannot find spreadCurrency2 in USD; Pair2Curr1="+Pair2Curr1+" Pair2Curr2="+Pair2Curr2+" App="+symbol_appendix+" Mode="+MarketInfo(spreadCurrency2,MODE_PROFITCALCMODE));
      deinit();
   }   

   amountpair1 = investment*pair2/(pair1+pair2);
   amountpair2 = investment*pair1/(pair1+pair2);
//TODO MT4 method to determine decimal points for lots???
   lot1 = NormalizeDouble(amountpair1/lotprice1,2);
   lot2 = NormalizeDouble(amountpair2/lotprice2,2);
   Print("amountpair1="+amountpair1+", amountpair2="+amountpair2+", lot1="+lot1+", lot2="+lot2);
   
   //Conversion Currency
   CurrencyConversion1 = "";
   if ((Pair1Curr2 != "USD") && (MarketInfo(spreadCurrency1,MODE_PROFITCALCMODE) == 0)){
      test = PairExists(Pair1Curr2+"USD"+symbol_appendix);
      CurrencyConversion1=Pair1Curr2+"USD"+symbol_appendix;
   }   
   if (!test && (MarketInfo(spreadCurrency1,MODE_PROFITCALCMODE) == 0)){
         CurrencyConversion1="USD"+Pair1Curr2+symbol_appendix;
   }

   CurrencyConversion2 = "";
   if ((Pair2Curr2 != "USD") && (MarketInfo(spreadCurrency2,MODE_PROFITCALCMODE) == 0)){
      test = PairExists(Pair2Curr2+"USD"+symbol_appendix);
      CurrencyConversion2=Pair2Curr2+"USD"+symbol_appendix;
   }   
   if (!test && (MarketInfo(spreadCurrency2,MODE_PROFITCALCMODE) == 0)){
         CurrencyConversion2="USD"+Pair2Curr2+symbol_appendix;
   }
   //Print("CurrencyConversion1="+CurrencyConversion1+" CurrencyConversion2="+CurrencyConversion2);
   
   
   string sa1="B";
   if (!spreadAction1) sa1="S";
   string sa2="B";
   if (!spreadAction2) sa2="S";
   
   IndicatorShortName("SP("+spreadCurrency1+sa1+" "+spreadCurrency2+sa2+" Sz="+DoubleToStr(MarketInfo(Symbol(),MODE_MINLOT),2)+")");
//   IndicatorShortName("spreadProfit (" + spreadCurrency1 + "@" + DoubleToStr(spreadOpen1,4) + " " + spreadCurrency2 + "@" + DoubleToStr(spreadOpen2,4) + " MinLot=" + DoubleToStr(MarketInfo(Symbol(),MODE_MINLOT),2) + ")");
   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,2);
   SetIndexBuffer(0,sp); SetIndexLabel(0,"SP");
   
   return(0);
}

//------------------------------------------------------------------------
//
//
int deinit()
{
   return(0);
}

//------------------------------------------------------------------------
//
//
int start()
{

   int i,r,limit,counted_bars = IndicatorCounted();
      
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (ArrayRange(sp,0) != Bars) ArrayResize(sp,Bars);


      double point     = Point; if (Digits==3 || Digits==5) point *= 10;
      for (i=limit, r=Bars-i-1; i >= 0; i--, r++)
      {
         sp[i] = NormalizeDouble(spreadProfit(i),2);
      }
   return(0);
}

//------------------------------------------------------------------------
//
//
double spreadProfit(int shift)
{
   double profit1=0.0;
   if (spreadAction1) {
      profit1 = iClose(spreadCurrency1,0,shift)-spreadOpen1;
   }
   else{
      profit1 = spreadOpen1-iClose(spreadCurrency1,0,shift);
   }   
   profit1 = profit1*lot1*lotsize1;
   if ((Pair1Curr2 != "USD") && (MarketInfo(spreadCurrency1,MODE_PROFITCALCMODE) == 0)){
      profit1 = profit1/MarketInfo(CurrencyConversion1,MODE_BID);
   }   

   
   double profit2=0.0;
   if (spreadAction2) {
      profit2 = iClose(spreadCurrency2,0,shift)-spreadOpen2;
   }
   else{
      profit2 = spreadOpen2-iClose(spreadCurrency2,0,shift);
   } 
   profit2 = profit2*lot2*lotsize2;
   if ((Pair2Curr2 != "USD") && (MarketInfo(spreadCurrency2,MODE_PROFITCALCMODE) == 0)){
      profit2 = profit2/MarketInfo(CurrencyConversion2,MODE_BID);
   }   

   //if (shift < 2) Print("SP1="+profit1+", SP2="+profit2);
   return(profit1+profit2);
}

//------------------------------------------------------------------------
//
//
bool PairExists (string TradeSymbol)
{
   return ( MarketInfo (TradeSymbol, MODE_LOTSIZE) > 0 );
}

